
Ruby - Bug #12494

win32/resolv.rb may add outdated nameservers

06/15/2016 06:18 PM - valentyn (Valentijn Sessink)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3:

UNKNOWN

Description

When using Ruby on Windows, the Resolv class may use outdated nameservers without notice.

This is due to the fact that win32/resolv.rb walks the Registry and adds nameservers from all interfaces, including the ones that have

a link down status. Code:

reg.open('Interfaces') do |reg|

reg.each_key do |iface,|

reg.open(iface) do |regif|

begin

[ 'NameServer', 'DhcpNameServer' ].each do |key|

ns = regif.read_s(key)

unless ns.empty?

nameserver.concat(ns.split(/[,\s]\s*/))

When interface 1 has 8.8.8.8 for DhcpNameServer but the interface is down, and interface 2 has 10.something for nameserver, then

still 8.8.8.8 will be queried by Resolv.

Related issues:

Has duplicate Ruby - Bug #12604: Win32::Resolv.get_resolv_info returns unavai... Closed

History

#1 - 07/21/2016 01:30 AM - nobu (Nobuyoshi Nakada)

- Has duplicate Bug #12604: Win32::Resolv.get_resolv_info returns unavailable DNS servers added

#2 - 08/24/2019 02:34 AM - jeremyevans0 (Jeremy Evans)

- Status changed from Open to Closed
